'use strict';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var debug = require('debug')('feathers-authentication-keystone:verify');

module.exports = function () {
  function KeystoneVerifier(app) {
    var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

    _classCallCheck(this, KeystoneVerifier);

    this.app = app;
    this.options = options;

    this.service = typeof options.service === 'string' ? app.service(options.service) : options.service;

    if (!this.service) {
      throw new Error('options.service does not exist.\n\tMake sure you are passing a valid service path or service instance and it is initialized before feathers-authentication-keystone.');
    }

    this.verify = this.verify.bind(this);
  }

  _createClass(KeystoneVerifier, [{
    key: 'verify',
    value: function verify(req, identity, done) {
      debug('Received Keystone identity:', identity);

      var user = {
        id: identity.user.id,
        username: identity.user.name,
        token: identity.token,
        expires_at: identity.expires_at
      };

      var payload = _defineProperty({}, this.options.entity + 'Id', identity.user.id);

      return done(null, user, payload);
    }
  }]);

  return KeystoneVerifier;
}();